    .text
    .globl _start
    .type _start,#function

_start:
    b _reset    /* reset, interrupt table */
    b _reset
    b _reset
    b _reset
    b _reset
    b _reset
    b _safe_irq_handler
    b _reset
_reset:
    mov sp, #0x100000      /* set the stack top (1M) */
    sub sp, sp, #4         /* minus 4 */

    /* set up memory region 0 -- the whole 4GB address space */
    mov r0, #63  /* region data */
    mcr p15, 0, r0, c6, c0, 0
    mcr p15, 0, r0, c6, c0, 1
    /* set up region 1 which is the first 2 megabytes. */
    mov r0, #0x00000029  /* region data */
    mcr p15, 0, r0, c6, c1, 0
    mcr p15, 0, r0, c6, c1, 1
    /* set region 1 to be cacheable (so the first 2M will be cacheable) */
    mov r0, #2
    mcr p15, 0, r0, c2, c0, 0
    mcr p15, 0, r0, c2, c0, 1
    /* set region 1 to be bufferable too (only data) */
    mcr p15, 0, r0, c3, c0, 0


;    b .skip
    /* set protection on for all regions */
    mov r0, #15
    mcr p15, 0, r0, c5, c0, 0
    mcr p15, 0, r0, c5, c0, 1

    mrc p15, 0, r0, c1, c0, 0 /* fetch current control reg */
    orr r0, r0, #1            /* 0x00000001: enable protection unit */
    orr r0, r0, #4            /* 0x00000004: enable D cache */
    orr r0, r0, #0x1000       /* 0x00001000: enable I cache */
    orr r0, r0, #0xC0000000   /*  0xC0000000: async+fastbus */
    mcr p15, 0, r0, c1, c0, 0 /* set control reg */

    /* Set 940T to 200MHz*/
    ldr r1,gp2x_regs
    mov r0,#0x4900
    orr r0,r0,#0x4
    mov r2,#0x0910
    strh r0,[r1,r2]
    sub r2,r2,#0x0e
0:
    ldrh r0,[r1,r2]
    tst r0,#0x1
    bne 0b
.skip:


    bl PASCALMAIN

    .globl  _haltproc
    .type   _haltproc,#function
_haltproc:
    b _haltproc


_safe_irq_handler:
    sub lr, lr, #4
    mov sp, #0x100000
    stmfd sp!, {r0 - r12, lr}
    /*bl irq_handler*/
    ldmfd sp!, {r0 - r12, pc}^

gp2x_regs: .word 0xC0000000-0x3000000
